{ lib, stdenv, fetchgit, nim, nimblePackages }:

stdenv.mkDerivation rec {
  pname = "device_manager";
  version = "0.0";
  outputs = [ "out" "dhall" ];

  src = fetchgit {
    url = "https://git.sr.ht/~ehmry/${pname}";
    rev = "6770ca1d2b08ae0cc9954db797cdd484bc0dc554";
    sha256 = "1c8pb6blay6szfxwpss81d39258vrfqjvycaiis71a5d0anzs1ap";
  };

  nimFlags = with nimblePackages;
    map (lib: "--path:${lib}/src") [ genode ] ++ [ "-d:posix" ];

  nativeBuildInputs = [ nim ];

  preHook = ''
    export HOME="$NIX_BUILD_TOP"
  '';

  buildPhase = ''
    runHook preBuild
    nim cpp $nimFlags src/$pname
    runHook postBuild
  '';

  installPhase = ''
    install -Dt $out/bin src/$pname
    install -Dt $dhall config/package.dhall
  '';
}
